import { ItemModule } from './controller/item/item.module';
import { ItemGateway } from './controller/item/item.gateway';
import { OrderDataGateway } from './controller/orderdata/orderdata.gateway';
import { OrderDataModule } from './controller/orderdata/orderdata.module';
import { OrdersGateway } from './controller/orders/orders.gateway';
import { OrdersModule } from './controller/orders/orders.module';
import { SupplierGateway } from './controller/supplier/supplier.gateway';
import { Module } from '@nestjs/common';

import * as mongoose from 'mongoose';
mongoose.set('useFindAndModify', false)

import { MongooseModule } from '@nestjs/mongoose';

import { UserModule } from './controller/user/user.module';
import { GlobalGateway } from './global.gateway';

import { AuthModule } from './controller/auth/auth.module';
import { SupplierModule } from './controller/supplier/supplier.module';
import { ShipperModule } from './controller/shipper/shipper.module';
import { ShipperGateway } from './controller/shipper/shipper.gateway';
import { EventEmitter } from 'events';
import { PaymentModule } from './controller/payment/payment.module';
import { PaymentGateway } from './controller/payment/payment.gateway';
import { ShipperBillGateway } from './controller/shipper-bill/shipper-bill.gateway';
import { ShipperBillModule } from './controller/shipper-bill/shipper-bill.module';
EventEmitter.defaultMaxListeners=1024;


@Module({
  imports: [
    MongooseModule.forRoot('mongodb://localhost/nest'),
    AuthModule,
    UserModule,
    SupplierModule,
    ShipperModule,
    OrdersModule,
    OrderDataModule,
    PaymentModule,
    ItemModule,
    ShipperBillModule,

  ],
  controllers: [],
  providers: [
    EventEmitter,
    GlobalGateway,
    ShipperGateway,
    SupplierGateway,
    OrdersGateway,
    OrderDataGateway,
    PaymentGateway,
    ItemGateway,
    ShipperBillGateway,

    // UserGateway,UserService,HashService
  ],
})
export class AppModule {

}
