import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { AuthSchema } from './auth.model';
import { AuthService } from './auth.service';
import { AuthGateway } from './auth.gateway';
import { UserModule } from '../user/user.module';

@Module({
  imports: [
    UserModule,
    MongooseModule.forFeature([{ name: 'Auth', schema:AuthSchema }
  ]),
],
  controllers: [],
  providers: [AuthGateway,AuthService],
  exports:[AuthService]
})
export class AuthModule {
  constructor(){
    console.log("Auth Module.");
    
  }
}