import { Supplier } from '../supplier/supplier.model';
import { Document, Schema as mSchame } from 'mongoose';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Shipper } from '../shipper/shipper.model';
@Schema()
export class Item extends Document {
     //_id?:string;

     @Prop({
          default: Date.now
     })
     date: Date;

     //连接供应商id 数组
     @Prop({
          type: [mSchame.Types.ObjectId],
          ref: "Supplier"
     })
     suppliers: string;
     //产品照片
     @Prop({
          type: [String],
     })
     images: string[];
     //分类
     @Prop({
          type:Number,
     })
     classes : number;
     //标签
     @Prop({
          type: [String],
     })
     tabs: string[];

     @Prop({
          default: "none"
     })
     no: string;
     @Prop({
          default: " "
     })
     name: string;

     @Prop({
          default: 1
     })
     box: number;

     @Prop({
          default: 0
     })
     qty: number;

     @Prop({
          default: 0
     })
     price: number;

     @Prop({
          default: 1
     })
     discount: number;

     //状态
     @Prop({ default: 0 })
     state: number;
     //备注
     @Prop()
     mark: string;

     //外箱规格
     @Prop({ default: [0, 0, 0] })
     size: number[];
     //外箱重量
     @Prop({ default: [0, 0] })
     weight: number[];

}

export const ItemSchema = SchemaFactory.createForClass(Item);