import { Supplier } from '../supplier/supplier.model';
import { Document ,Schema as mSchame} from 'mongoose';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Shipper } from '../shipper/shipper.model';
@Schema()
export class OrderData extends Document  {
     //_id?:string;
     @Prop({
          default:Date.now
     })
     date: Date;
     //连接订单id
     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Orders"
     })
     order:string;
     //连接供应商id
     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Supplier"
     })
     supplier:string;
     //连接物流id
     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Shipper"
     })
     shipper:string;

     //连接产品id
     @Prop({
          default:null,
          type:mSchame.Types.ObjectId,
          ref:"Item"
     })
     link:string;

     @Prop({
          default:"none"
     })
     no: string;
     @Prop({
          default:" "
     })
     name: string;

     @Prop({
          default:1
     })
     box: number;

     @Prop({
          default:0
     })
     qty: number;

     @Prop({
          default:0
     })
     price: number;

     @Prop({
          default:1
     })
     discount: number;
     //运费
     @Prop()
     fare: number;
     //总额
     @Prop()
     total:number;

     //状态
     @Prop({default:0})
     state:number;
     //备注
     @Prop()
     mark:string;

     @Prop({default:0})
     size:number;
     @Prop({default:0})
     weight:number;


}

export const OrderDataSchema = SchemaFactory.createForClass(OrderData);