import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket,Client,Server} from 'socket.io';
import { ResultDTO } from 'src/result.dto';
import { UserService } from '../user/user.service';
import { OrdersService } from './orders.service';
import { UseGuards } from '@nestjs/common';
import { AuthGuard } from 'src/guard/auth.guard';
import { AuthModule } from '../auth/auth.module';


@WebSocketGateway({namespace: 'api'})

export class OrdersGateway {
    
    constructor(private _user:UserService,private _Orders:OrdersService) {
        console.log('Orders gateway readed.');
    }

    
    @SubscribeMessage('ordersGet')
    //@UseGuards(AuthGuard)
    Get( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('E OrdersGet',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Orders.Get(filter).then(docs=>{
                console.log("F OrdersGet:",docs.length);
                if(docs){
                    result.ok=1;
                    result.msg= "Geted.Order"
                    result.count=docs.length;
                    result.data=docs
                    resolve(result)
                }
            })
        }) 
    }

    @SubscribeMessage('ordersGetOne')
    GetOne( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('OrdersGetOne',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Orders.GetOne(filter).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
            })
        })
    }

    @SubscribeMessage('ordersAdd')
    Add(client: Socket, data: any): Promise<ResultDTO> {
        console.log('OrdersAdd',data);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Orders.Add(data).then(doc=>{
                if(doc){
                    this._Orders.GetOne(doc).then(_data=>{
                        result.ok=1;
                        result.msg= "Added."
                        result.count=1;
                        result.data=_data
                        resolve(result)
                    })
                }   
        })
        })

        
    }

    
    @SubscribeMessage('ordersUpd')
    Update(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            let result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            this._Orders.Update(data).then(doc=>{
                //发布更新
                client.emit("freshOrder",doc)

                console.log('UPD',doc)
                result.msg='Upded Order'
                result.data=doc;
                resolve(result)
            })
           
        })
    }

    @SubscribeMessage('ordersDelete')
    Delete(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            console.log("删除",data);
            let result=new ResultDTO();
            this._Orders.GetOne({'_id':data}).then(doc=>{
                console.log('查获',doc);
                if(doc){
                    doc.state=1;
                    // 遍历订单数据 修改 state

                    doc.save();
                    // this._Orders.Delete(doc._id).then(ret=>{
                    //     console.log('del ret',ret);
                    //     if(ret.deletedCount>0){
                    //         result.ok=1;
                    //         result.msg=`已删除数据: ${ret.deletedCount}`;
                    //         // this.updateOrder(doc.order).then(order=>{
                    //         //     client.emit('freshOrder',order)
                    //         // })
                    //         resolve(result);
                    //     }else{
                    //         console.log("无可删除数据");
                    //         result.ok=0;
                    //         result.msg="无可删除数据."
                    //         resolve(result);
                    //     }
                        
                    // })
                }else{
                    console.log("无可删除数据");
                    result.ok=0;
                    result.msg="无可删除数据."
                    resolve(result);
                }
                
            }).catch(error=>{
                result.ok=0;
                result.msg=error.message;
                reject(result)
            })
        })
    }
    
}
