import { Supplier } from './../supplier/supplier.model';
import { Document ,Schema as mSchame} from 'mongoose';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Shipper } from '../shipper/shipper.model';
@Schema()
export class Orders extends Document  {
     //_id?:string;
     
     @Prop({
          default:Date.now
     })
     create_date: Date;
     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Supplier"
     })
     supplier:string;

     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Shipper"
     })
     shipper:string
     
     @Prop({default:0})
     box: number;
     //运费
     @Prop({default:0})
     shipping_cost: number;
     //运单
     @Prop()
     shipping_voucher: string;
     //总额
     @Prop({default:0})
     total:number;
     //支付
     @Prop({default:0})
     payment:number;
     //余额
     @Prop({default:0})
     balance:number;

     @Prop({default:0})
     size:number;
     @Prop({default:0})
     weight:number;
     
     //状态
     @Prop({default:0})
     state:number;
     //备注
     @Prop()
     mark:string;
}

export const OrdersSchema = SchemaFactory.createForClass(Orders);