import { Supplier } from '../supplier/supplier.model';
import { Document ,Schema as mSchame} from 'mongoose';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Shipper } from '../shipper/shipper.model';
@Schema()
export class Payment extends Document  {
     //_id?:string;
     //信息创建时间
     @Prop({
          default:Date.now
     })
     create_date: Date;
     //支付时间
     @Prop({
          default:Date.now
     })
     pay_date: Date;

     //金额变动类型 1 支付,2 调整. 调整金额 不统计 不显示在财务管理
     @Prop({
          default:1
     })
     pay_type:number;

     //关联订单
     @Prop({
          type:mSchame.Types.ObjectId,
     })
     orders:string;

     //收款公司
     @Prop({
          type:mSchame.Types.ObjectId,
          ref:"Supplier"
     })
     supplier:string;

     //支付金额
     @Prop({default:0})
     payment:number;

     //状态 1整除 0作废
     @Prop({default:0})
     state:number;
     //备注
     @Prop()
     mark:string;
}

export const PaymentSchema = SchemaFactory.createForClass(Payment);
