import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket} from 'socket.io';
import { ResultDTO } from 'src/result.dto';
import { ShipperBillService } from './shipper-bill.service';



@WebSocketGateway({namespace: 'api'})

export class ShipperBillGateway {
    
    constructor(private _ShipperBill:ShipperBillService) {
        console.log('ShipperBill gateway readed.');
    }

    
    @SubscribeMessage('ShipperBillGet')
    //@UseGuards(AuthGuard)
    Get( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('ShipperBillGet',filter);
        return new Promise((resolve, reject) =>{
            const result=new ResultDTO();
            this._ShipperBill.Get(filter).then(docs=>{
                console.log("Finded:",docs.length);
                if(docs){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=docs.length;
                    result.data=docs
                    resolve(result)
                }
            })
        }) 
    }

    @SubscribeMessage('ShipperBillGetOne')
    GetOne( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('ShipperBillGetOne',filter);
        return new Promise((resolve, reject) =>{
            const result=new ResultDTO();
            this._ShipperBill.GetOne(filter).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
            })
        })
    }

    @SubscribeMessage('ShipperBillAdd')
    Add(client: Socket, data: any): Promise<ResultDTO> {
        console.log('ShipperBillAdd',data);
        return new Promise((resolve, reject) =>{
            const result=new ResultDTO();
            this._ShipperBill.Add(data).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Added."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
                
        })
        })

        
    }

    
    @SubscribeMessage('ShipperBillUpd')
    Update(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            const result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            this._ShipperBill.Update(data).then(doc=>{
                console.log('UPD',doc)
                result.msg='Upded'
                result.data=doc;
                resolve(result)
            })
           
        })
    }

    @SubscribeMessage('ShipperBillDelete')
    Delete(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            const result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            resolve(result)
        })
    }
    
}
