import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { Document, Schema as mSchame } from 'mongoose';

@Schema()
export class ShipperBill extends Document {
     //_id?:string;

     //发货人
     @Prop({
          type: mSchame.Types.ObjectId,
          ref: "Supplier"
     })
     supplier: string;
     //物流公司
     @Prop({
          type: mSchame.Types.ObjectId,
          ref: "Shipper"
     })
     shipper: string;

     @Prop({
          default: new Date()
     })
     date: Date;

     //运单号
     @Prop({
          default:'000000'
     })
     no: string;

     //箱数
     @Prop({
          default:0
     })
     box: number
     //验收
     @Prop({
          default:0
     })
     got: number

     
     //重量
     @Prop({
          default:0
     })
     weight: number
     //大小
     @Prop({
          default:0
     })
     size: number


     //计费单价
     @Prop({
          default:0
     })
     price: number

     //计费方式
     @Prop({
          default:0
     })
     paytype: number

     //总金额
     @Prop({
          default:0
     })
     total: number


}

export const ShipperBillSchema = SchemaFactory.createForClass(ShipperBill);