import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket,Client,Server} from 'socket.io';
import { ResultDTO } from 'src/result.dto';
import { UserService } from '../user/user.service';
import { ShipperService } from './shipper.service';
import { UseGuards } from '@nestjs/common';
import { AuthGuard } from 'src/guard/auth.guard';
import { AuthModule } from '../auth/auth.module';


@WebSocketGateway({namespace: 'api'})

export class ShipperGateway {
    
    constructor(private _user:UserService,private _Shipper:ShipperService) {
        console.log('Shipper gateway readed.');
    }

    
    @SubscribeMessage('shipperGet')
    //@UseGuards(AuthGuard)
    Get( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('ShipperGet',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Shipper.Get(filter).then(docs=>{
                console.log("Finded:",docs.length);
                if(docs){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=docs.length;
                    result.data=docs
                    resolve(result)
                }
            })
        }) 
    }

    @SubscribeMessage('shipperGetOne')
    GetOne( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('ShipperGetOne',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Shipper.GetOne(filter).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
            })
        })
    }

    @SubscribeMessage('shipperAdd')
    Add(client: Socket, data: any): Promise<ResultDTO> {
        console.log('ShipperAdd',data);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._Shipper.Add(data).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Added."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
                
        })
        })

        
    }

    
    @SubscribeMessage('shipperUpd')
    Update(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            let result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            this._Shipper.Update(data).then(doc=>{
                console.log('UPD',doc)
                result.msg='Upded'
                result.data=doc;
                resolve(result)
            })
           
        })
    }

    @SubscribeMessage('shipperDelete')
    Delete(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            let result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            resolve(result)
        })
    }
    
}
