import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket} from 'socket.io';
import { ResultDTO } from 'src/result.dto';
import { UserService } from '../user/user.service';
import { SupplierService } from './supplier.service';


@WebSocketGateway({namespace: 'api'})

export class SupplierGateway {
    
    constructor(private _user:UserService,private _supplier:SupplierService) {
        console.log('Supplier gateway readed.');
    }

    
    @SubscribeMessage('supplierGet')
    //@UseGuards(AuthGuard)
    Get( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('supplierGet',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._supplier.Get(filter).then(docs=>{
                console.log("Finded:",docs.length);
                if(docs){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=docs.length;
                    result.data=docs
                    resolve(result)
                }
            })
        }) 
    }

    @SubscribeMessage('supplierGetOne')
    GetOne( client: Socket, filter: any): Promise<ResultDTO> {
        console.log('supplierGetOne',filter);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._supplier.GetOne(filter).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Geted."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
            })
        })
    }

    @SubscribeMessage('supplierAdd')
    Add(client: Socket, data: any): Promise<ResultDTO> {
        console.log('supplierAdd',data);
        return new Promise((resolve, reject) =>{
            let result=new ResultDTO();
            this._supplier.Add(data).then(doc=>{
                if(doc){
                    result.ok=1;
                    result.msg= "Added."
                    result.count=1;
                    result.data=doc
                    resolve(result)
                }
                
        })
        })

        
    }

    
    @SubscribeMessage('supplierUpd')
    Update(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            let result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            this._supplier.Update(data).then(doc=>{
                console.log('UPD',doc)
                result.msg='Upded'
                result.data=doc;
                resolve(result)
            })
           
        })
    }

    @SubscribeMessage('supplierDelete')
    Delete(client: Socket, data: any): Promise<ResultDTO> {
        return new Promise((resolve, reject)=>{
            let result=new ResultDTO();
            result.ok=1;
            //判断当前用户等级
            resolve(result)
        })
    }
    
}
