import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket,Client,Server} from 'socket.io';
import { UserService } from './user.service';
import { User ,UserDTO} from './user.model';
import { ResultDTO } from 'src/result.dto';
import { AuthService } from '../auth/auth.service';

@WebSocketGateway({namespace: 'api'})

export class UserGateway {
    constructor(private _user:UserService) {
        console.log('User gateway readed.');
    }
    @SubscribeMessage('userLogin')
    login(client: Socket, login_data: User): Promise<ResultDTO> {
        console.log('a login',login_data);
        return new Promise((resolve, reject) =>{
            this._user.login(login_data).then(user=>{
                const result=new ResultDTO();
                console.log("user:",user);
                if(user){
                    result.ok=1;
                    result.msg= "登录许可已颁发."
                    //登录成功 传入_id 生成一个hash 返回. 用作自动登录
                    // this._auth.create(user._id,7).then(hash=>{
                    //     result.hash=hash.key;
                    //     console.log("result:",result);
                    //     resolve(result);
                    // });
                    
                    
                }else{
                    result.msg='用户名或密码错误!';
                    result.ok=-1;
                    resolve(result)
                }
            })
            
        })
    }


    @SubscribeMessage('userCheck')
    check(client: Socket, data: UserDTO): Promise<User> {
        console.log('a check',data);
        return null;
        // return new Promise<string>((resolve, reject) =>{
        //     resolve("hashhashhashhashhashhashhash")
        // })

    }

    @SubscribeMessage('userCreate')
    create(client: Socket, data: UserDTO): Promise<User> {
        console.log('a create',data);
        return this._user.create(data);
        // return new Promise<string>((resolve, reject) =>{
        //     resolve("hashhashhashhashhashhashhash")
        // })

    }
}
