import { Document } from 'mongoose';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';

export class UserDTO {
     username: string;
     hash: string;
     level: number;
}
export class OnlineConfig{
  socksId:string;
  user:UserDTO;
}


@Schema()
export class User extends Document  {
  @Prop({ 
    type:String,
    trim: true,
    maxlength:32,
    minlength:8
  })
  username: string;

  @Prop({
    type:String,
    trim: true,
    select:false,
    maxlength:32,
    minlength:8
  })
  password: string;

  @Prop({
    maxlength:32,
    minlength:32
  }
  )
  hash: string;

  @Prop({
    default:'guest',
    enum: ['root','admin','user1','user2','guest']
  })
  role: string;

  @Prop({
    default:0,
  })
  state: number;

}


export const UserSchema = SchemaFactory.createForClass(User);