import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { UserSchema } from './user.model';
import { UserGateway } from './user.gateway';
import { UserService } from './user.service';


@Module({
  imports: [
    MongooseModule.forFeature([{ name: 'User', schema: UserSchema }]),
  ],
  controllers: [],
  providers: [UserGateway,UserService],
  exports:[UserService]
})
export class UserModule {
  constructor(){
    console.log("User Module.");
    
  }
}