import { Model } from 'mongoose';
import { Injectable, Inject } from '@nestjs/common';
import { InjectModel } from '@nestjs/mongoose';
import { User,UserDTO, OnlineConfig } from './user.model';

@Injectable()
export class UserService {
  public  onlinelist:OnlineConfig[]=[];
  
  constructor(
    @InjectModel('User') public userModel: Model<User>,
    ) {
    console.log('User Service ');
  }

  model(){
    return this.userModel;
  }
  userliset(){
    return this.onlinelist
  }
  
 

  async create(userDto: UserDTO): Promise<User> {
    const createUser = new this.userModel(userDto);
    return createUser.save();
  }

  async login(userDto:User): Promise<User> {
    return this.userModel.findOne(userDto);
  }

  async listUsers(): Promise<User[]|null> {
    return this.userModel.find().exec();
  }

  checkLevel(socksId:string,level:number){
    return this.onlinelist.filter(i=>{
      return i.socksId==socksId &&i.user.level<=level 
    }).length>0
  }
  currentUser(socksId:string):OnlineConfig{
    return this.onlinelist.find(i=>{
       console.log(socksId);
       console.log(i.socksId);
     return i.socksId==socksId})
  }
  async findOne(filter){
    return await this.userModel.findOne(filter)
  }

}
