import { SubscribeMessage, WebSocketGateway } from '@nestjs/websockets';
import { Socket,Client,Server} from 'socket.io';
import { ResultDTO } from './result.dto';
import { UserService } from './controller/user/user.service';
import { User, OnlineConfig, UserDTO } from './controller/user/user.model';



@WebSocketGateway({namespace: 'api'})

export class GlobalGateway {
    constructor(private _user:UserService) {
        console.log('Global gateway readed.');
    }

    public afterInit() {
        console.log("WebSocket init.");
    }
    
    //新的会话 设置客户为 gust
    public handleConnection(client: Client) {
        console.log("Client --- " + client.id );
        const newUser:OnlineConfig=new OnlineConfig();
        newUser.socksId=client.id;
        const guest=new UserDTO();
        guest.username="guest";
        guest.level=3;
        newUser.user=guest;
        this._user.onlinelist.push(newUser)
        //console.log('online:',this._user.onlinelist);
    }

    //msg
    public bindMessageHandlers(client: Client) {
        console.log("MSG -|- " + client.id );
    }
   
}
